Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.http.io
Interface SessionInputBuffer

All Known Implementing Classes:
  AbstractSessionInputBuffer, SessionInputBufferImpl, SocketInputBuffer

    public interface SessionInputBuffer

Session input buffer for blocking connections. This interface is similar to InputStream class, but it also provides methods for reading lines of text.

Implementing classes are also expected to manage intermediate data buffering for optimal input performance.

Since:
  4.0

Method Summary
`HttpTransportMetrics` | `getMetrics()` Returns `HttpTransportMetrics` for this session buffer.
`boolean` | `isDataAvailable(int timeout)` Deprecated. (4.3) do not use. This function should be provided at the connection level
`int` | `read()` Reads the next byte of data from this session buffer.
`int` | `read(byte[] b)` Reads some number of bytes from the session buffer and stores them into the buffer array `b`.
`int` | `read(byte[] b, int off, int len)` Reads up to `len` bytes of data from the session buffer into an array of bytes.
`String` | `readLine()` Reads a complete line of characters up to a line delimiter from this session buffer.
`int` | `readLine(CharArrayBuffer buffer)` Reads a complete line of characters up to a line delimiter from this session buffer into the given line buffer.

Method Detail

### read

    int read(byte[] b,
             int off,
             int len)
             throws IOException

  Reads up to `len` bytes of data from the session buffer into an array of bytes. An attempt is made to read as many as `len` bytes, but a smaller number may be read, possibly zero. The number of bytes actually read is returned as an integer.

  This method blocks until input data is available, end of file is detected, or an exception is thrown.

  If `off` is negative, or `len` is negative, or `off+len` is greater than the length of the array `b`, then an `IndexOutOfBoundsException` is thrown.

  Parameters:
    `b` - the buffer into which the data is read.
    `off` - the start offset in array `b` at which the data is written.
    `len` - the maximum number of bytes to read.
  Returns:
    the total number of bytes read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    int read(byte[] b)
             throws IOException

  Reads some number of bytes from the session buffer and stores them into the buffer array `b`. The number of bytes actually read is returned as an integer. This method blocks until input data is available, end of file is detected, or an exception is thrown.

  Parameters:
    `b` - the buffer into which the data is read.
  Returns:
    the total number of bytes read into the buffer, or `-1` is there is no more data because the end of the stream has been reached.
  Throws:
    `IOException` - if an I/O error occurs.

### read

    int read()
             throws IOException

  Reads the next byte of data from this session buffer. The value byte is returned as an `int` in the range `0` to `255`. If no byte is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Returns:
    the next byte of data, or `-1` if the end of the stream is reached.
  Throws:
    `IOException` - if an I/O error occurs.

### readLine

    int readLine(CharArrayBuffer buffer)
                 throws IOException

  Reads a complete line of characters up to a line delimiter from this session buffer into the given line buffer. The number of chars actually read is returned as an integer. The line delimiter itself is discarded. If no char is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, end of file is detected, or an exception is thrown.

  The choice of a char encoding and line delimiter sequence is up to the specific implementations of this interface.

  Parameters:
    `buffer` - the line buffer.
  Returns:
    one line of characters
  Throws:
    `IOException` - if an I/O error occurs.

### readLine

    String readLine()
                    throws IOException

  Reads a complete line of characters up to a line delimiter from this session buffer. The line delimiter itself is discarded. If no char is available because the end of the stream has been reached, `null` is returned. This method blocks until input data is available, end of file is detected, or an exception is thrown.

  The choice of a char encoding and line delimiter sequence is up to the specific implementations of this interface.

  Returns:
    HTTP line as a string
  Throws:
    `IOException` - if an I/O error occurs.

### isDataAvailable

    @Deprecated
    boolean isDataAvailable(int timeout)
                            throws IOException

  Deprecated. (4.3) do not use. This function should be provided at the connection level

  Blocks until some data becomes available in the session buffer or the given timeout period in milliseconds elapses. If the timeout value is `0` this method blocks indefinitely.

  Parameters:
    `timeout` - in milliseconds.
  Returns:
    `true` if some data is available in the session buffer or `false` otherwise.
  Throws:
    `IOException` - if an I/O error occurs.

### getMetrics

    HttpTransportMetrics getMetrics()

  Returns `HttpTransportMetrics` for this session buffer.

  Returns:
    transport metrics.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2005–2021 The Apache Software Foundation. All rights reserved.